#!/usr/bin/perl
# Simple SMTP server
# (for testing purpose)

use IO::Socket::INET;
my $server_port = 25;
my $domain = 'my.domain.com';
my $server = IO::Socket::INET->new(LocalPort => $server_port,
                                Type      => SOCK_STREAM,
                                Reuse     => 1,
                                Listen    => 10 )   # or SOMAXCONN
    or die "Couldn't be a tcp server on port $server_port: $!\n";
while (my $client = $server->accept()) {
		$client->send("220 $domain service ready.\r\n");
		my $buf = "";
		my $datamode = 0;
		while ($_ = $client->getline) {
			s/\r\n/\n/g;
			if ($datamode == 1) {
				$buf .= $_;
				if (/^\.\n$/) {
					$datamode = 0;
					$client->send("250 Requested mail action okay, completed\r\n");
					open(F,">msg.eml") || die "open error:$!\n";
					print F $buf;
					close(F);
					$buf = "";
				}
			}
			elsif (/^EHLO/) { $client->send("250 Requested mail action okay, completed\r\n");}
			elsif (/^HELO/) { $client->send("250 Requested mail action okay, completed\r\n");}
			elsif (/^RSET/) { $client->send("250 Requested mail action okay, completed\r\n");}
			elsif (/^MAIL FROM/) { $client->send("250 Requested mail action okay, completed\r\n");}
			elsif (/^RCPT TO/) { $client->send("250 Requested mail action okay, completed\r\n");}
			elsif (/^DATA/) {
				$client->send("354 Start mail input; end with <CRLF>.<CRLF>\r\n");
				$datamode=1;
			}
			elsif (/^QUIT/) {
				$client->send("221 $domain Service closing transmission channel\r\n");
				undef $client;
				last;
			}
			else {
				$client->send("502 Command not implemented\r\n");
			}
		}
}

close($server);